/*
 * source/Other/Init.c
 * SpacePigs VectorMania Main Program (probably only mainloop)
 *
 * 1991-04-14 : Coding begun
 */

#include <stdlib.h>

#include <exec/types.h>
#include <exec/ports.h>
#include <intuition/intuition.h>
#include <devices/inputevent.h>

#include <proto/exec.h>
#include <proto/intuition.h>

#include "other/debug.h"
#include "vector/vector.h"
#include "graphics/graphics.h"
#include "edit/edit.h"

struct click {
    USHORT secs;
    USHORT mics;
    long data;
    int doubleclick;
};

static struct MsgPort *IDCMPPort;

static int cleanup(int code);
static BOOL DoIDCMP(struct IntuiMessage * im);
static int mousebutton = 0;

void main(void)
{
    LONG idcmpsigmask;
    LONG waitsigmask;
    LONG wokesigmask;
    struct IntuiMessage *im;

    BOOL KeepGoing = TRUE;

    onexit(cleanup);

    IDCMPPort = CreatePort("VectorMania IDCMP", 0);
    if (!IDCMPPort)
	ERROR("Can't create IDCMPPort\n", 20);
    initgfx(IDCMPPort);
    initedit();

    idcmpsigmask = 1 << IDCMPPort->mp_SigBit;

    waitsigmask = idcmpsigmask;

    while (KeepGoing) {
	wokesigmask = Wait(waitsigmask);
	if (wokesigmask & idcmpsigmask) {
	    while (KeepGoing) {
		im = (struct IntuiMessage *) GetMsg(IDCMPPort);
		if (im == NULL)
		    break;
		KeepGoing = DoIDCMP(im);
	    }
	}
    }

    saydebug("Quiting\n", 0);

    exit(0);
}

static int cleanup(int code)
{
    closeedit();
    closegfx();
    if (IDCMPPort)
	DeletePort(IDCMPPort);
    return code;
}

/* checkclickdelay:
** Kollar om det r ett dubbelclick inom given tidsram (preferences)
*/
static BOOL
 checkclickdelay(long data, struct click * old, struct click * time, int realdouble)
{
    BOOL doubleclick = FALSE;
    if (realdouble && (!old->doubleclick) && data == old->data)
	if (DoubleClick(old->secs, old->mics, time->secs, time->mics))
	    doubleclick = TRUE;
    old->data = data;
    old->secs = time->secs;
    old->mics = time->mics;
    old->doubleclick = doubleclick;
    return doubleclick;
}

/* checkclick:
** Kollar om det var ett dubbelclick frut... inte tidsberoende.
*/
static BOOL
 checkclick(long data, struct click * old, struct click * time, int realdouble)
{
    if (!realdouble)
	old->doubleclick = FALSE;
    return (BOOL) old->doubleclick;
}

static BOOL
 DoIDCMP(struct IntuiMessage * im)
{
    struct Window *win;
    WINDOWDATA *windat;
    WINDOWTYPE type;
    ULONG class;
    USHORT code;
    USHORT qualifier;
    int mousex, mousey;
    int smousex, smousey;
    APTR iaddress;
    int doubleclick = 0;
    int editdoubleclick;
    struct click click;
    BOOL keepgoing = TRUE;
    static struct click doubleclickdata;
    int mouseinwindow;

    if (!im)
	return FALSE;

    win = im->IDCMPWindow;
    windat = (WINDOWDATA *) win->UserData;
    type = windat->type;

    class = im->Class;
    code = im->Code;
    qualifier = im->Qualifier;
    iaddress = im->IAddress;
    mousex = im->MouseX;
    mousey = im->MouseY;
    if (win->Flags & GIMMEZEROZERO) {
	mousex -= win->BorderLeft;
	mousey -= win->BorderTop;
    }
    click.secs = im->Seconds;
    click.mics = im->Micros;

    mouseinwindow = 1;
    if (mousex < windat->minx)
	mouseinwindow = 0;
    if (mousex > windat->maxx)
	mouseinwindow = 0;
    if (mousey < windat->miny)
	mouseinwindow = 0;
    if (mousey > windat->maxy)
	mouseinwindow = 0;

    smousex = mousex;
    smousey = mousey;

    rescaleeditcord(&mousex, &mousey, windat);
    editdoubleclick = checkifeditdoubleclick(smousex, smousey, type);
    doubleclick = checkclick(windat->type, &doubleclickdata,
				  &click, editdoubleclick);

    /**********************************************************/
    /* Hr, fre reply skall hantering av menuverify mm ligga */
    /**********************************************************/
    switch (class) {
    case IDCMP_MENUVERIFY:
	if ((code == MENUHOT) && (qualifier & IEQUALIFIER_LEFTBUTTON) && mouseinwindow) {
	    im->Code = MENUCANCEL;
	    ReplyMsg((struct Message *) im);
	    keepgoing = mousemenudown(mousex, mousey, doubleclick,
				      windat);
	    return keepgoing;
	}
	break;
    case IDCMP_INTUITICKS:
	if (qualifier & IEQUALIFIER_LEFTBUTTON && mouseinwindow && mousebutton) {
	    keepgoing = mouseselectdown(mousex, mousey, doubleclick,
					windat);
	}
	break;
    }

    ReplyMsg((struct Message *) im);

    switch (class) {
    case IDCMP_CLOSEWINDOW:
	if (type == WINDOW_DRAW) {
	    keepgoing = FALSE;
	}
	closeeditwindow(windat);
	break;
    case IDCMP_NEWSIZE:
	getwindowdata(windat);
	newsize(windat);
	break;
    case IDCMP_ACTIVEWINDOW:
	activewindow(windat);
	break;
    case IDCMP_INACTIVEWINDOW:
	inactivewindow(windat);
	break;
    case IDCMP_RAWKEY:
	keepgoing = rawkey(code, qualifier, doubleclick, windat);
	break;
    case IDCMP_MOUSEBUTTONS:
	switch (code) {
	case SELECTUP:
	    mousebutton = FALSE;/* Fr IDCMP_INTUITICK */
	    keepgoing = mouseselectup(mousex, mousey,
				      doubleclick, windat);
	    break;
	case SELECTDOWN:
	    mousebutton = TRUE;	/* Fr IDCMP_INTUITICK */
	    if (!mouseinwindow)
		break;
	    editdoubleclick = checkeditdoubleclick(smousex, smousey, type);
	    doubleclick = checkclickdelay(windat->type, &doubleclickdata,
				     &click, editdoubleclick);
	    keepgoing = mouseselectdown(mousex, mousey, doubleclick,
					windat);
	    break;
	}
	break;
    case IDCMP_GADGETDOWN:
	{
	    struct Gadget *gad = (struct Gadget *) iaddress;
	    int selected;
	    GADGETID id;

	    id = (GADGETID) gad->GadgetID;
	    selected = gad->Flags & SELECTED;

	    keepgoing = gadgetdown(id, selected, doubleclick, windat);
	}
	break;
    case IDCMP_GADGETUP:
	{
	    struct Gadget *gad = (struct Gadget *) iaddress;
	    int selected;
	    GADGETID id;

	    id = (GADGETID) gad->GadgetID;
	    selected = gad->Flags & SELECTED;

	    keepgoing = gadgetup(id, selected, doubleclick, windat);
	}
	break;
    case IDCMP_MENUPICK:
	{
	    long selection;
	    struct MenuItem *item;
	    struct Menu *menu;
	    selection = code;
	    menu = windat->menudat->menu;
	    while (keepgoing && (selection != MENUNULL)) {
		item = ItemAddress(menu, selection);
		if (item) {
		    keepgoing = handlemenu(MENUNUM(selection),
			  ITEMNUM(selection), SUBNUM(selection), doubleclick,windat);
		    selection = item->NextSelect;
		} else {
		    keepgoing = FALSE;
		}
	    }
	    if (keepgoing)
		keepgoing = handlemenu_end(windat);
	}
	break;
    case IDCMP_INTUITICKS:
    case IDCMP_MENUVERIFY:
	break;
    default:
	saydebug("IDCMP: Not Supported %x\n", class);
	break;
    }
    return keepgoing;
}
